/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: dllapi.cpp,v 1.46 2004/03/18 19:14:35 punisher Exp $ */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include "statsme.h"

char		szBuffor[2048];
player_t	players[33];
sm_t		sm;
motd_t*		sm_motd;
action_t*	sm_menu;
action_t*	sm_pmenu;
action_t *	sm_alias;
task_t*		sm_task;
myvar_t*	sm_var;
grenades_t*	sm_grenades;

void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax )
{
	// reset same SM global values
	sm.mapstart_time = gpGlobals->time + 0.25;
	sm.gm_accurate = players;
	sm.gm_killer = players;
	sm.gm_disruptive = players;
	sm.rnd_accurate = players;
	sm.rnd_killer = players;
	sm.rnd_disruptive = players;
	sm.c4_timer = 0;
	sm.endround_time = 0;
	sm.endmap_time = 0;
	sm.game_timeleft = 0;
	sm.game_restarting = 0;
	sm.newround_time = 0;
	sm.task_time = 0;
	sm.engine_task = 0;

	// load configuration if sm_refresh is set
	if ( sm_refresh->value ) {
		CVAR_SET_FLOAT("sm_refresh", 0);
		LOG_MESSAGE(PLID,   "Executing statsme config file" );
		const char* sm_cfgfile  = LOCALINFO("sm_cfgfile");
		if ( *sm_cfgfile )	{
			SERVER_COMMAND( UTIL_VarArgs( "exec %s\n", sm_cfgfile )  );
		}
		else {
#ifdef ADDON_LAYOUT
			SERVER_COMMAND( "exec addons/statsme/statsme.cfg\n"  );
#else
			SERVER_COMMAND( "exec statsme.cfg\n" );
#endif
		}
	}
	
	// reset some stats and players vars
	memset(players,0,sizeof(player_t)*33);
	memset(sm.roundstats,0,sizeof(stat_t)*4);
	memset(sm.gamestats,0,sizeof(stat_t)*4);
	memset(&sm.all_roundstats,0,sizeof(stat_t));
	memset(&sm.all_gamestats,0,sizeof(stat_t));

	// refresh tasks
	for( task_t*p = sm_task; p ; p = p->next ) {
		 p->time = p->root_time;
	}

	// assign stats tables to pointers
	for (int i = 0; i <= gpGlobals->maxClients; ++i) { // with "zero" player for "best stats in game" comperation
		player_t* pPlayer = GET_PLAYER_POINTER_I(i);
		pPlayer->pGm_stats = &pPlayer->aGm_stats;
		pPlayer->pWpn_stats = pPlayer->aWpn_stats;
		pPlayer->pMon_stats = &pPlayer->aMon_stats;
		pPlayer->pPpl_stats = pPlayer->aPpl_stats;
		pPlayer->pAPpl_stats = pPlayer->aAPpl_stats;
		pPlayer->pRnd_stats = &pPlayer->aRnd_stats;
	}

	if ( !gmsgHealth ) {// do init below only once
		mp_timelimit	=	CVAR_GET_POINTER("mp_timelimit");
		if ( mp_timelimit == NULL )	{
			LOG_MESSAGE(PLID, "ERROR: (mp_timelimit) couldn't find the pointer.");
		}
		gmsgCurWeapon	=	GET_USER_MSG_ID(PLID, "CurWeapon", NULL );
		gmsgDamage		=	GET_USER_MSG_ID(PLID, "Damage", NULL );
		gmsgDeathMsg	=	GET_USER_MSG_ID(PLID, "DeathMsg", NULL );
		gmsgTextMsg		=	GET_USER_MSG_ID(PLID, "TextMsg", NULL );
		gmsgTeamInfo	=	GET_USER_MSG_ID(PLID, "TeamInfo", NULL );
		gmsgWeaponList	=	GET_USER_MSG_ID(PLID, "WeaponList", NULL );
		gmsgResetHUD	=   GET_USER_MSG_ID(PLID, "ResetHUD", NULL );
		gmsgMOTD		=	GET_USER_MSG_ID(PLID, "MOTD", NULL );
		gmsgServerName	=	GET_USER_MSG_ID(PLID, "ServerName", NULL );
		gmsgHealth		=	GET_USER_MSG_ID(PLID, "Health", NULL);
		gmsgBattery		=	GET_USER_MSG_ID(PLID, "Battery", NULL);
		gmsgShowMenu	=	GET_USER_MSG_ID(PLID, "ShowMenu", NULL);
		gmsgSendAudio	=	GET_USER_MSG_ID(PLID, "SendAudio", NULL);
		gmsgTeamScore	=	GET_USER_MSG_ID(PLID, "TeamScore", NULL);
		gmsgMoney		=	GET_USER_MSG_ID(PLID, "Money", NULL);
		gmsgBleeding	=	GET_USER_MSG_ID(PLID, "Bleeding", NULL);
		gmsgBandaging	=	GET_USER_MSG_ID(PLID, "Bandaging", NULL);
		gmsgScreenFade  =	GET_USER_MSG_ID(PLID, "ScreenFade",NULL);
		gmsgScoreInfo	=	GET_USER_MSG_ID(PLID, "ScoreInfo", NULL);
//		gmsgInitHUD		=	GET_USER_MSG_ID(PLID, "InitHUD", NULL);

		// find out the intermission - this is exception in MM
		for(int a=0,size=0; a < MAX_REG_MSGS; ++a)	{
			const char *cp=GET_USER_MSG_NAME(PLID, a, &size);
			if( cp && !strcmp("intermission?",cp) )	{
				gmsgintermission = a;
				break;
			}
		}

		if ( gmsgintermission == 0 ) {
			LOG_MESSAGE(PLID, "ERROR: (intermission) no type for message.");
		}
		
		// engine messages		
		switch ( sm.mod_id )
		{
			case MOD_CSTRIKE:
			//	modMsgs[gmsgWeaponList].function = Client_WeaponList_CS;
				modMsgs[gmsgBattery].function = Client_Battery;
				modMsgs[gmsgShowMenu].function = Client_ShowMenu;
				modMsgs[gmsgCurWeapon].function = Client_CurWeapon_CS;
				modMsgs[gmsgTeamInfo].function = Client_TeamInfo;
				modMsgs[gmsgTeamScore].function = Client_TeamScore;	
				modMsgs[gmsgDamage].function = Client_Damage_CS;
				modMsgs[gmsgDeathMsg].function = Client_DeathMsg_CS;
				modMsgs[gmsgTextMsg].function = Client_TextMsg_CS;
				modMsgs[gmsgSendAudio].function = Client_SendAudio_CS;
				modMsgs[gmsgHealth].function = Client_Health;
				modMsgs[gmsgMoney].function = Client_Money_CS;
				modMsgsEnd[gmsgResetHUD].function = Client_ResetHUD_End_CS;
				modMsgsEnd[gmsgintermission].function = Client_intermission_End;
				break;
			case MOD_DOD:	
				modMsgs[gmsgBattery].function = Client_Battery;
				modMsgs[gmsgShowMenu].function = Client_ShowMenu;
				modMsgs[gmsgCurWeapon].function = Client_CurWeapon_DOD;
				modMsgs[gmsgTeamInfo].function = Client_TeamInfo;
				modMsgs[gmsgTeamScore].function = Client_TeamScore;	
				modMsgs[gmsgHealth].function = Client_Health_DOD;
				modMsgs[gmsgDeathMsg].function = Client_DeathMsg_DOD;
				modMsgs[gmsgBleeding].function = Client_Bleeding_DOD;
				modMsgs[gmsgBandaging].function = Client_Bandaging_DOD;
				modMsgs[gmsgScreenFade].function = Client_ScreenFade_DOD;
				modMsgsEnd[gmsgintermission].function = Client_intermission_End;
				modMsgsEnd[gmsgResetHUD].function = Client_ResetHUD_End_DOD;
				break;
			case MOD_TFC:
				modMsgs[gmsgBattery].function = Client_Battery;
				modMsgs[gmsgShowMenu].function = Client_ShowMenu;
		//		modMsgs[gmsgInitHUD].function = Client_InitHUD_TFC;
				//modMsgs[gmsgCurWeapon].function = Client_CurWeapon_TFC;
				modMsgs[gmsgTeamInfo].function = Client_TeamInfo;
				modMsgs[gmsgTeamScore].function = Client_TeamScore;	
				modMsgs[gmsgDeathMsg].function = Client_DeathMsg_TFC;
				modMsgs[gmsgWeaponList].function = Client_WeaponList_TFC;
				//modMsgs[gmsgDamage].function = Client_Damage_TFC;
				modMsgs[gmsgHealth].function = Client_Health;
				modMsgs[gmsgScoreInfo].function = Client_ScoreInfo_TFC;
				modMsgsEnd[gmsgResetHUD].function = Client_ResetHUD_End;
				modMsgsEnd[gmsgintermission].function = Client_intermission_End;
				break;
			case MOD_VALVE:
				modMsgs[gmsgBattery].function = Client_Battery;
				modMsgs[gmsgShowMenu].function = Client_ShowMenu;
				modMsgs[gmsgTeamInfo].function = Client_TeamInfo;
				modMsgs[gmsgHealth].function = Client_Health;
				modMsgs[gmsgTeamScore].function = Client_TeamScore;
				modMsgs[gmsgWeaponList].function = Client_WeaponList;
				modMsgs[gmsgCurWeapon].function = Client_CurWeapon;
				modMsgs[gmsgDeathMsg].function = Client_DeathMsg;
				modMsgsEnd[gmsgResetHUD].function = Client_ResetHUD_End;
				modMsgsEnd[gmsgintermission].function = Client_intermission_End;
				break;
			default:
				modMsgs[gmsgBattery].function = Client_Battery;
				modMsgs[gmsgShowMenu].function = Client_ShowMenu;
				modMsgs[gmsgTeamInfo].function = Client_TeamInfo;
				modMsgs[gmsgHealth].function = Client_Health;
				modMsgs[gmsgTeamScore].function = Client_TeamScore;
				modMsgs[gmsgWeaponList].function = Client_WeaponList;
				modMsgs[gmsgCurWeapon].function = Client_CurWeapon;
				modMsgs[gmsgDeathMsg].function = Client_DeathMsg;
				modMsgsEnd[gmsgResetHUD].function = Client_ResetHUD_End;
				modMsgsEnd[gmsgintermission].function = Client_intermission_End;
				break;
		}		
	}

	RETURN_META(MRES_IGNORED);
}

void ServerDeactivate( void ) 
{
	// disconnect all players for SM
	for(int a = 1; a <= gpGlobals->maxClients; ++a ){
		player_t *pPlayer = GET_PLAYER_POINTER_I(a);
		if ( pPlayer->ingame ) 
			PlayerDisconnect( pPlayer );
	}

	// save rank if logfile set
	if ( *sm_ranklogfile->string ){
		char game_dir[256];
		GET_GAME_DIR(game_dir);
		//LOG_MESSAGE(PLID, UTIL_Pathname("Saving statsme rank (file \"%s/statsme.log\") (game \"%s\") (version \"%d\")" , 
		//	game_dir, sm.mod_name, VRANKVERSION)  );
		SaveRank();
	} else {
		LOG_MESSAGE(PLID, "Skipping save. No sm_ranklogfile."); 
	}

	// delete some task - other with flag "c" leave for next map
	task_t*p = sm_task;
	while( p ){
		if (p->flags&4) {
			p = p->next;	
			continue;
		}
		task_t* next = p->next;
		if (p->prev)
			p->prev->next = next;
		else
			sm_task = next;
		 if (next)
			 next->prev = p->prev;
		 delete[] p->cmd;
		 delete p;
		 p = next;
	}

	 while (sm_grenades){
		grenades_t*to_del = sm_grenades;
		sm_grenades = sm_grenades->next;
		delete to_del;
	 }

	// delete list of all engine tasks
	while (sm_engtask){
		engtask_t*to_del = sm_engtask;
		sm_engtask = sm_engtask->next;
		delete[] to_del->cmd;
		delete to_del;
	}

	// if sm_refresh is set the delete whole statsme configuration
	if ( sm_refresh->value ) {
		LOG_MESSAGE(PLID,   "Removing statsme configuration" );
		DeleteConfiguration();
	}
	
	RETURN_META(MRES_IGNORED);
}

void PlayerPreThink( edict_t *pEntity ) 
{
	player_t *pPlayer = sm.player = GET_PLAYER_POINTER(pEntity);

	// latency measure by PsychoGuard
    if ( pPlayer->lat_time  && pPlayer->lat_time < gpGlobals->time){	
		pPlayer->lat_time = gpGlobals->time + sm_latlogfreq->value;
		int ping = 0;
		int packet_loss = 0;
		PLAYER_CNX_STATS( pEntity , &ping, &packet_loss);		
		if ( ping )	{
			pPlayer->lat_sum += ping;
			pPlayer->lat_samples++;

			if (sm_pingspike->value && ping > sm_pingspike->value)
				pPlayer->lat_spikes++;


		}
	}

	// check for monster kill
	if ( pPlayer->monster_time && pPlayer->monster_time < gpGlobals->time) {
		pPlayer->monster_time = 0;
		if ( pPlayer->pMon_stats->kills >= sm_monsternum->value ) {
			pPlayer->custom = pPlayer->pMon_stats;
			PARSE_MESSAGE_BEGIN( SM_MONSTERKILL ,pPlayer, pPlayer->index );
				PARSE_WRITE_BYTE( pPlayer->custom->kills );
				PARSE_WRITE_BYTE( pPlayer->custom->hs );
			PARSE_MESSAGE_END();
		}
		// Time out so clear monster kill stats
		memset(&pPlayer->aMon_stats,0,sizeof(stat_t));
	}

	// delay statsme menu (coz menu is done by server commands)
	if ( pPlayer->menu_time && pPlayer->menu_time < gpGlobals->time){
		pPlayer->menu_time = 0;
		SettingsMenu(pPlayer, pPlayer->menu_state,pPlayer->menu_src);
	}

	RETURN_META(MRES_IGNORED);
}

// this is called from specific mod startframe func.
void StartFrame( void )
{
	// this is just after map start - fire event, precompile cvars and load top15
	if ( sm.mapstart_time && sm.mapstart_time < gpGlobals->time) {
		sm.mapstart_time  = 0;
		PARSE_MESSAGE_BEGIN( SM_MAPSTART );
		PARSE_MESSAGE_END();

		if ( *sm_ranklogfile->string ) {
			LoadRank();
		}
		else {//no file given so don't load and only check when rank should be cleared

			LOG_MESSAGE(PLID, "Skipping load. No sm_ranklogfile."); 

			time_t now;	time(&now);
			if ( sm_resetrank->value && difftime(now, sm.last_reset ) > (sm_resetrank->value * 3600) )	{
				DeleteStats(&sm_rank, &sm_rank_last); //reset stats
				time(&sm.last_reset); //save date of this reset
			}
		}
	}

	// execute server commands from engine messaging
	if ( sm.engine_task < gpGlobals->time ) {
		sm.engine_task = gpGlobals->time + 0.015;
		if ( sm_engtask ) {
			if (sm_engtask->done) {
				engtask_t*a = sm_engtask;
				sm_engtask = sm_engtask->next;
				delete[] a->cmd;
				delete a;
			} else {
				sm.sm_mode_bits = sm_engtask->flag;
				sm.sm_mode_id = sm_engtask->id;
				SERVER_COMMAND(sm_engtask->cmd);
				sm_engtask->done = true;
			}
		}
	}

	// tasks
	if ( sm.task_time < gpGlobals->time ) {
		sm.task_time = gpGlobals->time + 1.0; // check every 1.0 sec.
		task_t *p = sm_task;
		 while ( p ) {
			if ( !p->time || p->time > gpGlobals->time ) {
				p = p->next;
				continue;
			}
			char* cmdtodo = (p->flags&1) ? smv_putvars( p->cmd ) : p->cmd;
			if (cmdtodo && *cmdtodo) SERVER_COMMAND( cmdtodo );
			if ( p->flags&4 ){ // refresh on new map
				p->time = 0;
				p = p->next;
			}
			else if ( p->flags&2 ) { // repeat continusly
				p->time = gpGlobals->time + p->root_time;
				p = p->next;
			}
			else {
				task_t* next = p->next;
				if (p->prev)
					p->prev->next = next;
				else
					sm_task = next;
				if (next)
					next->prev = p->prev;
				delete[] p->cmd;
				delete p;
				p = next;
			}
		}
	}


	// intermission is on and delay has been achived - show stats to all players
	if (sm.endmap_time && sm.endmap_time < gpGlobals->time)	{
		sm.endmap_time = 0;

		if ( *sm.sm_mode & 1 ) {
			for (int a = 1; a <= gpGlobals->maxClients; ++a) {
				player_t* pPlayer = GET_PLAYER_POINTER_I(a);
				if ( pPlayer->ingame && !pPlayer->bot)	{
					UTIL_ShowMOTD(pPlayer->pEdict, MakeStats( pPlayer, szBuffor ),
						STRING( pPlayer->pEdict->v.netname ));
				}
			}
		}
	}
	RETURN_META(MRES_IGNORED);
}

void PlayerConnect(edict_t *pEntity, const char *pszName, const char *pszAddress)
{
	int index = ENTINDEX(pEntity);
	player_t* pPlayer = sm.player = GET_PLAYER_POINTER_I(index);
	pPlayer->pEdict = pEntity;
	pPlayer->index = index;
	pPlayer->bot = strcmpi( GETPLAYERAUTHID(pEntity), "BOT" ) ? false : true;
	pPlayer->play_time = gpGlobals->time; //start time counting like original "status"
	strncpy(pPlayer->name,pszName,32); // save name
	pPlayer->name[31]=0;
	strcpy(pPlayer->team_name, sm.team_name[0]);
	strcpy(pPlayer->ip, pszAddress );

	if ( pPlayer->bot )	{
			pPlayer->connect_time = 0;
	} else {
		pPlayer->connect_time = gpGlobals->time + 2.0;
		for(motd_t*p = sm_motd; p ; p = p->next){
			char* motd = smv_putvars(p->msg);
			if ( motd && *motd )
				CLIENT_COMMAND(pEntity ,"echo %s\n", motd);
		}
	}
		
	PARSE_MESSAGE_BEGIN( SM_CONNECT ,pPlayer , index );
		PARSE_WRITE_STRING(pszName);
		PARSE_WRITE_STRING(pszAddress);
	PARSE_MESSAGE_END();
}

void PlayerPutInServer( player_t* pPlayer )
{
	pPlayer->ingame	= true; // player has passed connection and successfuly has entered to the game
	pPlayer->pRank = FindThePositionInRank( pPlayer->name,GETPLAYERAUTHID(pPlayer->pEdict) );
	pPlayer->lat_time = ( sm_latlogfreq->value ) ? (gpGlobals->time + sm_latlogfreq->value) : 0.0;

	pPlayer->lat_samples = 0;
	pPlayer->lat_sum = 0;
	
	ResetStats( pPlayer );
	PARSE_MESSAGE_BEGIN( SM_PUTINSERVER , sm.player = pPlayer , pPlayer->index  );
	PARSE_MESSAGE_END();
}

void PlayerDisconnect( player_t *pPlayer)
{
	PARSE_MESSAGE_BEGIN( SM_DISCONNECT , sm.player = pPlayer , pPlayer->index );
	PARSE_MESSAGE_END();

	pPlayer->pRank->playtime += int(gpGlobals->time - pPlayer->play_time);

	//Go through weapons stats and log only fired/used weapons
	for (int i = 0; i < MAX_WEAPONS ; ++i)
	{
		if ( pPlayer->pWpn_stats[i].shots || pPlayer->pWpn_stats[i].kills )
		{
			pPlayer->custom = &pPlayer->pWpn_stats[i];
			
			if ( *sm_logformat->string )
#ifdef ADDON_LAYOUT
				if (sm_addonlogformat->value != 2) {
					ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"weaponstats\" %s",
						STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
						GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
						smv_putvars(sm_logformat->string)); }
				if (sm_addonlogformat->value != 1) {
					ALERT( at_logged,"[%s] \"%s<%d><%s><%s>\" triggered \"weaponstats\" %s",Plugin_info.logtag,
						STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
						GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
						smv_putvars(sm_logformat->string)); }
#else
				ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"weaponstats\" %s",
					STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
					GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
					smv_putvars(sm_logformat->string));
#endif


			
			if ( *sm_logformat2->string )
#ifdef ADDON_LAYOUT
				if (sm_addonlogformat->value != 2) {
					ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"weaponstats2\" %s",
						STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
						GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
						smv_putvars(sm_logformat2->string)); }
				if (sm_addonlogformat->value != 1) {
					ALERT( at_logged,"[%s] \"%s<%d><%s><%s>\" triggered \"weaponstats2\" %s",Plugin_info.logtag,
						STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
						GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
						smv_putvars(sm_logformat2->string)); }
#else
				ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"weaponstats2\" %s",
					STRING( pPlayer->pEdict->v.netname ), 	GETPLAYERUSERID( pPlayer->pEdict ),
					GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
					smv_putvars(sm_logformat2->string));
#endif


		}
	}
	
	if ( *sm_latlogformat->string )
	{
#ifdef ADDON_LAYOUT
		if (sm_addonlogformat->value != 2) {
			ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"latency\" %s",
				STRING( pPlayer->pEdict->v.netname),   GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),   pPlayer->team_name,
				smv_putvars(sm_latlogformat->string)); }
		if (sm_addonlogformat->value != 1) {
			ALERT( at_logged,"[%s] \"%s<%d><%s><%s>\" triggered \"latency\" %s",Plugin_info.logtag,
				STRING( pPlayer->pEdict->v.netname),   GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),   pPlayer->team_name,
				smv_putvars(sm_latlogformat->string)); }

#else
		ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"latency\" %s",
			STRING( pPlayer->pEdict->v.netname),   GETPLAYERUSERID( pPlayer->pEdict ),
			GETPLAYERAUTHID( pPlayer->pEdict ),   pPlayer->team_name,
			smv_putvars(sm_latlogformat->string));
#endif

	}
	
	if ( *sm_timelogformat->string )
	{
#ifdef ADDON_LAYOUT
		if (sm_addonlogformat->value != 2) {
			ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"time\" %s",
				STRING( pPlayer->pEdict->v.netname),	GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
				smv_putvars(sm_timelogformat->string)); }
		if (sm_addonlogformat->value != 1) {
			ALERT( at_logged,"[%s] \"%s<%d><%s><%s>\" triggered \"time\" %s",Plugin_info.logtag,
				STRING( pPlayer->pEdict->v.netname),	GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
				smv_putvars(sm_timelogformat->string)); }
#else
		ALERT( at_logged,"\"%s<%d><%s><%s>\" triggered \"time\" %s",
			STRING( pPlayer->pEdict->v.netname),	GETPLAYERUSERID( pPlayer->pEdict ),
			GETPLAYERAUTHID( pPlayer->pEdict ),	pPlayer->team_name,
			smv_putvars(sm_timelogformat->string));
#endif
	}


	pPlayer->pRnd_stats->playtime = 10;
	pPlayer->pGm_stats->playtime = 10;
	if ( !pPlayer->bot || sm_rankbots->value ) 
	{
		if ( sm_rankupdate->value == 2 )
			ScorePlayerInRank( STRING(pPlayer->pEdict->v.netname), pPlayer->pRank, pPlayer->pRnd_stats );
		else if ( sm_rankupdate->value == 1 )
			ScorePlayerInRank( STRING(pPlayer->pEdict->v.netname), pPlayer->pRank, pPlayer->pGm_stats );
	}
	pPlayer->ingame	= false;

}

BOOL ClientConnect_Post( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
	if ( META_RESULT_ORIG_RET(BOOL) ) // if connected with success (also fixes TFC bug)
		PlayerConnect(pEntity, pszName, pszAddress);

	RETURN_META_VALUE(MRES_IGNORED, TRUE);
}

void ClientPutInServer( edict_t *pEntity ) 
{
	PlayerPutInServer( GET_PLAYER_POINTER(pEntity) );

	RETURN_META(MRES_IGNORED);
}

void ClientDisconnect( edict_t *pEntity ) 
{
	player_t* pPlayer = GET_PLAYER_POINTER(pEntity);

	if ( pPlayer->ingame )	// player can be already disconnected at server deactivation (for statsme)
		PlayerDisconnect( pPlayer );
	
	RETURN_META(MRES_IGNORED);
}

void ClientUserInfoChanged_Post( edict_t *pEntity, char *infobuffer ) 
{
	player_t *pPlayer = sm.player = GET_PLAYER_POINTER(pEntity);

	strcpy(pPlayer->info_off, INFOKEY_VALUE(infobuffer,sm_switchinfo->string));

	if ( pPlayer->ingame ) {
		PARSE_MESSAGE_BEGIN( SM_INFOCHANGED ,pPlayer , pPlayer->index );
		PARSE_MESSAGE_END();
		const char* name = INFOKEY_VALUE(infobuffer,"name");

		// if name has changed
		if ( strcmp( STRING(pEntity->v.netname), name ) ) {
			strncpy(pPlayer->name, name,32);  // save name	
			pPlayer->name[31] = 0;
			pPlayer->pRank = FindThePositionInRank( name, GETPLAYERAUTHID(pPlayer->pEdict) ); // find new position in stats
		}

		
	}

	RETURN_META(MRES_IGNORED);
}

void ClientCommand( edict_t *pEntity )
{
	player_t *pPlayer = sm.player = GET_PLAYER_POINTER(pEntity);
	const char* cmds = CMD_ARGV(0);
	const char* said = CMD_ARGV(1);
	if ( (sm_enabled->value == 0) && strcmp(cmds,"statsme_menu") && strcmp(cmds,"menuselect")) // all except statsme_menu
	{
		// statsme disabled .. dont start commands 
		RETURN_META(MRES_IGNORED);
	}
	else if ( *sm_rankcmd->string && !strcmp(cmds,sm_rankcmd->string) ) // top15
	{
		if ( FloodProtection( &pPlayer->alias_flood ) )
			ShowTopScore(pPlayer);
		
		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( *sm_statsmecmd->string && !strcmp(cmds,sm_statsmecmd->string) ) // statsme
	{
		if ( FloodProtection( &pPlayer->alias_flood ) )
			UTIL_ShowMOTD(pEntity, MakeStats( pPlayer, szBuffor ) , STRING( pEntity->v.netname ) );
		
		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( *sm_statscmd->string && !strcmp(cmds,sm_statscmd->string) ) // stats
	{ 
		if ( FloodProtection( &pPlayer->alias_flood) )
			StatsMenu(pPlayer, 0);

		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( !strcmp(cmds,"say") || !strcmp(cmds,"say_team") )
	{
		for (action_t*p=sm_alias;p;p=p->next)
		{
			if ( (p->flags & 1) || strcmpi(p->name, said ) ) continue; //don't accept if alias have flag "a" - alias for console
			
			if ( FloodProtection( &pPlayer->say_flood ) )
			{
				char*cmdtodo = smv_putvars( p->cmd );
				if ( cmdtodo && *cmdtodo ) SERVER_COMMAND( cmdtodo );
				
			}
			
			if (p->flags & 4) //flag "c" makes that this alias (as say command) can't be said by player
				RETURN_META(MRES_SUPERCEDE);
			else
				RETURN_META(MRES_IGNORED);
		}
	}
	else if ( pPlayer->menu_type != MENU_IDLE && !strcmp( cmds, "menuselect" ) )
	{
		int pressed_key = atoi(said);

		if ( ! ( pPlayer->menu_keys & ( 1 << (pressed_key - 1) ) ) )
			RETURN_META(MRES_SUPERCEDE); //don't allow to use menuselect x command when not available by slots
		
		if (pPlayer->menu_type == STATS_MENU)
		{
			int select_begin = (pPlayer->menu_state*8);
			switch(pressed_key){
			case 9:
				StatsMenu(pPlayer, pPlayer->menu_state+1);
				break;
			case 10:
				StatsMenu(pPlayer, pPlayer->menu_state-1);		
				break;
			default:
				select_begin += (pressed_key-1);
				UTIL_ShowMOTD(pEntity,MakeStats(pPlayer->menu_list[select_begin],szBuffor),
					STRING(pPlayer->menu_list[select_begin]->pEdict->v.netname ));
				StatsMenu(pPlayer, pPlayer->menu_state);
			}
		}
		else if (pPlayer->menu_type == SETTINGS_MENU)
		{
			int select_begin = (pPlayer->menu_state*8);
			switch(pressed_key){
			case 9:
				SettingsMenu(pPlayer, pPlayer->menu_state+1,pPlayer->menu_src);
				break;
			case 10:
				SettingsMenu(pPlayer, pPlayer->menu_state-1,pPlayer->menu_src);		
				break;
			default:{
				select_begin += (pressed_key-1);
				action_t*a=pPlayer->menu_src;
				for(int c = 0;c<select_begin;c++) a=a->next;
				char* pcmd = smv_putvars(a->cmd);
				if (pcmd && *pcmd) SERVER_COMMAND(pcmd);
				pPlayer->menu_time = gpGlobals->time + 0.2; //doh - we must use here delay
				}
			}
		}
		else if (pPlayer->menu_type == CUSTOM_MENU)	
		{

			if (sm_logmenuaction->value) 
#ifdef ADDON_LAYOUT
				ALERT( at_logged,"[%s] \"%s<%i><%s><%s>\" triggered \"menu_answer\" (menu \"%d\") (option \"%d\")\n",Plugin_info.logtag,
#else
				ALERT( at_logged,"\"%s<%i><%s><%s>\" triggered \"menu_answer\" (menu \"%d\") (option \"%d\")\n",
#endif
					STRING( pEntity->v.netname ), GETPLAYERUSERID( pEntity ),
					GETPLAYERAUTHID( pEntity ), pPlayer->team_name,pPlayer->menu_id,pressed_key);

			pPlayer->menu_type=MENU_IDLE;

			if (pressed_key == 10) pressed_key = 0; //slot10 should be treaten as 0 in menu

			if (pPlayer->menu_cmds[pressed_key] && *pPlayer->menu_cmds[pressed_key])
				SERVER_COMMAND(pPlayer->menu_cmds[pressed_key]);

		}

		RETURN_META(MRES_SUPERCEDE);
	}
	else if ( !strcmp(cmds,"statsme_menu") )
	{
		if ( *said ) { // only if there is password set and matches with given argument
			if ( *sm_menupassword->string )		{
				if (strcmp(sm_menupassword->string,said) )
					CLIENT_PRINTF(pEntity,print_console,"* Can't use main menu, bad password.\n");
				else 
					SettingsMenu(pPlayer, 0, pPlayer->menu_src = sm_menu );
			}
			else {
				CLIENT_PRINTF(pEntity,print_console,"* Can't use main menu, password is not set.\n");
			}
		}
		

		RETURN_META(MRES_SUPERCEDE);
	}
	
	for (action_t*p=sm_alias;p;p=p->next)
	{
		if ( (p->flags & 2) || strcmpi(p->name, cmds ) ) continue; //don't accept if alias have flag "b" - alias for say
		
		if ( FloodProtection( &pPlayer->alias_flood) )
		{
			char*cmdtodo = smv_putvars( p->cmd );
			if ( cmdtodo && *cmdtodo )	SERVER_COMMAND( cmdtodo );
		}

		if (p->flags & 4) // for console command it is oposite to said alias
			RETURN_META(MRES_IGNORED);	
		else
			RETURN_META(MRES_SUPERCEDE);
	}

	RETURN_META(MRES_IGNORED);
}

DLL_FUNCTIONS gFunctionTable_Post;
C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable_Post.pfnServerActivate = ServerActivate_Post;
	gFunctionTable_Post.pfnClientConnect = ClientConnect_Post;
	gFunctionTable_Post.pfnClientUserInfoChanged = ClientUserInfoChanged_Post;
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ){
	gFunctionTable.pfnClientDisconnect = ClientDisconnect;
	gFunctionTable.pfnClientCommand = ClientCommand;
	gFunctionTable.pfnPlayerPreThink = PlayerPreThink;
	gFunctionTable.pfnClientPutInServer = ClientPutInServer;
	gFunctionTable.pfnServerDeactivate = ServerDeactivate;

	switch ( sm.mod_id ) 
	{
		case MOD_CSTRIKE:
			gFunctionTable.pfnStartFrame = StartFrame_CS;
			break;
		case MOD_DOD:
			gFunctionTable.pfnStartFrame = StartFrame;
			break;
		case MOD_TFC:
			gFunctionTable.pfnStartFrame = StartFrame;
			break;
		case MOD_VALVE:
			gFunctionTable.pfnStartFrame = StartFrame;
			break;
		default:
			gFunctionTable.pfnStartFrame = StartFrame;
			break;
	}
	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,					// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,					// pfnGetEntityAPI_Post			META; called after game DLL
	GetEntityAPI2,			// pfnGetEntityAPI2				HL SDK2; called before game DLL
	GetEntityAPI2_Post,		// GetEntityAPI2_Post,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,					// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,					// GetNewDLLFunctions_Post,	// pfnGetNewDLLFunctions_Post	META; called after game DLL
	GetEngineFunctions,		// pfnGetEngineFunctions		META; called before HL engine
	NULL	// pfnGetEngineFunctions_Post	META; called after HL engine
};
